module.exports = {
	"parser": "babel-eslint",
	"env": {
		"browser": true,
		"es6": true,
		"node": true,
		"jasmine": true
	},
	"globals": {
		"__DEV__": true
	},
    "parserOptions": {
        "ecmaVersion": 2017,
        "sourceType": "module"
    },
	"plugins": [
        "babel",
		"cumul8",
		"import",
		"jsx-a11y",
        "react"
	],
	"rules": {
		// ERRORS

		"accessor-pairs": 2,
		"array-bracket-spacing": [2, "never"],
		"arrow-spacing": [2, {"before": true, "after": true}],
		"babel/arrow-parens": [2, "always"],
		"babel/object-curly-spacing": [2, "never"],
		"block-scoped-var": 2,
		"block-spacing": [2, "always"],
		"brace-style": [2, "1tbs", {"allowSingleLine": true}],
		"comma-dangle": [2, "never"],
		"comma-spacing": [2, {"before": false, "after": true}],
		"comma-style": [2, "last"],
		"computed-property-spacing": [2, "never"],
		"consistent-return": 2,
		"consistent-this": 2,
		"constructor-super": 2,
		"cumul8/alphabetical-destructuring": 2,
		"cumul8/alphabetical-stylesheets": 2,
		"cumul8/inefficient-for-each": 2,
		"cumul8/inefficient-for-loop": 2,
		"dot-location": [2, "property"],
		"dot-notation": 2,
		"eqeqeq": [2, "allow-null"],
		"func-call-spacing": [2, "never"],
		"func-name-matching": 2,
		"func-style": [2, "expression"],
		"generator-star-spacing": [2, {"before": false, "after": true}],
		"guard-for-in": 2,
		"import/no-absolute-path": 2,
		"import/default": 2,
        "import/export": 2,
        "import/extensions": [2, "never"],
        "import/imports-first": 2,
        "import/named": 2,
        "import/namespace": 2,
        "import/newline-after-import": 2,
        "import/no-amd": 2,
        "import/no-commonjs": 2,
        "import/no-deprecated": 2,
        "import/no-duplicates": 2,
		"import/no-mutable-exports": 2,
        "import/no-named-as-default-member": 2,
		"import/no-named-default": 2,
        "import/no-namespace": 2,
        "import/no-unresolved": 2,
        "import/prefer-default-export": 2,
		"indent": [2, "tab", {"SwitchCase": 1}],
		"jsx-a11y/anchor-has-content": 2,
        "jsx-a11y/aria-props": 2,
        "jsx-a11y/aria-proptypes": 2,
        "jsx-a11y/aria-role": 2,
        "jsx-a11y/aria-unsupported-elements": 2,
        "jsx-a11y/heading-has-content": 2,
        "jsx-a11y/href-no-hash": 2,
        "jsx-a11y/html-has-lang": 2,
        "jsx-a11y/img-has-alt": 2,
        "jsx-a11y/img-redundant-alt": 2,
        "jsx-a11y/lang": 2,
        "jsx-a11y/mouse-events-have-key-events": 2,
        "jsx-a11y/no-access-key": 2,
        "jsx-a11y/no-marquee": 2,
        "jsx-a11y/no-onchange": 2,
        "jsx-a11y/onclick-has-focus": 2,
        "jsx-a11y/onclick-has-role": 2,
        "jsx-a11y/role-has-required-aria-props": 2,
        "jsx-a11y/role-supports-aria-props": 2,
        "jsx-a11y/scope": 2,
        "jsx-a11y/tabindex-no-positive": 2,
		"jsx-quotes": [2, "prefer-double"],
		"key-spacing": [2, {"mode": "strict", "beforeColon": false, "afterColon": true}],
		"keyword-spacing": [2, {"before": true, "after": true, "overrides": {}}],
		"lines-around-directive": [2, "always"],
		"max-depth": [2, 3],
		"max-len": [2, 150, 4],
		"max-lines": [2, {"max": 1000, "skipBlankLines": false, "skipComments": false}],
		"max-nested-callbacks": [2, 5],
		"max-params": [2, 4],
		"max-statements": [2, 100],
		"max-statements-per-line": [2, {"max": 2}],
		"newline-per-chained-call": [2, {"ignoreChainWithDepth": 3}],
		"new-parens": 2,
		"no-alert": 2,
		"no-array-constructor": 2,
		"no-bitwise": 2,
		"no-caller": 2,
		"no-catch-shadow": 2,
		"no-class-assign": 2,
		"no-cond-assign": 2,
		"no-const-assign": 2,
		"no-constant-condition": 2,
		"no-control-regex": 2,
		"no-debugger": 2,
		"no-delete-var": 2,
		"no-div-regex": 2,
		"no-dupe-args": 2,
		"no-dupe-class-members": 2,
		"no-dupe-keys": 2,
		"no-duplicate-case": 2,
		"no-duplicate-imports": 2,
		"no-else-return": 2,
		"no-empty": 2,
		"no-empty-character-class": 2,
		"no-empty-pattern": 2,
		"no-eval": 2,
		"no-ex-assign": 2,
		"no-extend-native": 2,
		"no-extra-bind": 2,
		"no-extra-boolean-cast": 2,
		"no-extra-semi": 2,
		"no-fallthrough": 2,
		"no-floating-decimal": 2,
		"no-func-assign": 2,
		"no-global-assign": 2,
		"no-implicit-coercion": [2, {"boolean": true, "number": true, "string": true}],
		"no-implicit-globals": 2,
		"no-implied-eval": 2,
		"no-inline-comments": 2,
		"no-inner-declarations": 2,
		"no-invalid-regexp": 2,
		"no-irregular-whitespace": 2,
		"no-iterator": 2,
		"no-labels": 2,
		"no-label-var": 2,
		"no-lone-blocks": 2,
		"no-lonely-if": 2,
		"no-loop-func": 2,
		"no-mixed-spaces-and-tabs": 2,
		"no-multi-spaces": 2,
		"no-multi-str": 2,
		"no-multiple-empty-lines": 2,
		"no-nested-ternary": 2,
		"no-new": 2,
		"no-new-func": 2,
		"no-new-object": 2,
		"no-new-symbol": 2,
		"no-new-wrappers": 2,
		"no-octal": 2,
		"no-octal-escape": 2,
		"no-obj-calls": 2,
		"no-process-env": 2,
		"no-proto": 2,
		"no-prototype-builtins": 2,
		"no-redeclare": 2,
		"no-regex-spaces": 2,
		"no-return-assign": 2,
		"no-script-url": 2,
		"no-self-assign": 2,
		"no-self-compare": 2,
		"no-sequences": 2,
		"no-shadow-restricted-names": 2,
		"no-sparse-arrays": 2,
		"no-template-curly-in-string": 2,
		"no-this-before-super": 2,
		"no-throw-literal": 2,
		"no-trailing-spaces": [2, {"skipBlankLines": false}],
		"no-undef": 2,
		"no-undef-init": 2,
		"no-unexpected-multiline": 2,
		"no-unmodified-loop-condition": 2,
		"no-unreachable": 2,
		"no-unsafe-finally": 2,
		"no-unsafe-negation": 2,
		"no-unused-expressions": 2,
		"no-unused-vars": [2, {"args": "none"}],
		"no-useless-computed-key": 2,
		"no-useless-constructor": 2,
		"no-useless-escape": 2,
		"no-useless-rename": [2, {
            "ignoreDestructuring": false,
            "ignoreImport": false,
            "ignoreExport": false
        }],
		"no-var": 2,
		"no-void": 2,
		"no-whitespace-before-property": 2,
		"no-with": 2,
		"object-shorthand": 2,
		"one-var-declaration-per-line": 2,
		"operator-assignment": [2, "always"],
		"operator-linebreak": [2, "after"],
		"prefer-arrow-callback": 2,
		"prefer-const": 2,
		"prefer-numeric-literals": 2,
		"prefer-spread": 2,
		"prefer-template": 2,
		"quote-props": [2, "as-needed"],
		"radix": 2,
		"react/display-name": [2, {"ignoreTranspilerName": true}],
		"react/forbid-prop-types": [2, {"forbid": ["any", "array", "object"]}],
		"react/jsx-boolean-value": [2, "always"],
		"react/jsx-closing-bracket-location": [2, {"location": "after-props"}],
		"react/jsx-curly-spacing": [2, "never"],
		"react/jsx-equals-spacing": [2, "never"],
		"react/jsx-indent-props": [2, "tab"],
		"react/jsx-indent": [2, "tab"],
		"react/jsx-key": 2,
		"react/jsx-max-props-per-line": [2, {"maximum": 4}],
		"react/jsx-no-comment-textnodes": 2,
		"react/jsx-no-duplicate-props": [2, {"ignoreCase": true}],
		"react/jsx-no-undef": 2,
		"react/jsx-no-target-blank": 2,
		"react/jsx-pascal-case": 2,
		"react/jsx-space-before-closing": [2, "always"],
		"react/jsx-sort-props": 2,
		"react/jsx-uses-react": 2,
		"react/jsx-uses-vars": 2,
		"react/jsx-wrap-multilines": 2,
		"react/no-children-prop": 2,
		"react/no-multi-comp": [2, {"ignoreStateless": true}],
		"react/no-danger": 2,
		"react/no-danger-with-children": 2,
		"react/no-deprecated": 2,
		"react/no-did-mount-set-state": 2,
		"react/no-did-update-set-state": 2,
		"react/no-direct-mutation-state": 2,
		"react/no-is-mounted": 2,
		"react/no-render-return-value": 2,
		"react/jsx-tag-spacing": [2, {
			"afterOpening": "never",
			"beforeSelfClosing": "always",
			"closingSlash": "never"
		}],
		"react/no-unescaped-entities": 2,
		"react/no-unknown-property": 2,
		"react/prop-types": [2, {"ignore": [
			"aria-label",
			"className",
			"children",
			"id",
			"onClick",
			"style"
		]}],
		"react/react-in-jsx-scope": 2,
		"react/require-optimization": 2,
		"react/require-render-return": 2,
		"react/self-closing-comp": [2, {"component": true, "html": true}],
		"react/sort-comp": [2, {
			"order": [
				"lifecycle",
				"render",
				"everything-else"
			],
			"groups": {
				"lifecycle": [
					"displayName",
					"mixins",
					"propTypes",
					"contextTypes",
					"childContextTypes",
					"statics",
					"loadProps",
					"defaultProps",
					"constructor",
					"getDefaultProps",
					"state",
					"getInitialState",
					"getChildContext",
					"componentWillAppear",
					"componentDidAppear",
					"componentWillEnter",
					"componentDidEnter",
					"componentWillMount",
					"componentDidMount",
					"componentWillReceiveProps",
					"shouldComponentUpdate",
					"componentWillUpdate",
					"componentDidUpdate",
					"componentWillLeave",
					"componentDidLeave",
					"componentWillUnmount"
				]
			}
		}],
		"react/sort-prop-types": 2,
		"react/style-prop-object": 2,
		"rest-spread-spacing": [2, "never"],
		"require-yield": 2,
		"semi": [2, "always"],
		"semi-spacing": [2, {"before": false, "after": true}],
		"sort-imports": [2, {
			"ignoreCase": true,
			"ignoreMemberSort": false,
			"memberSyntaxSortOrder": ["none", "all", "multiple", "single"]
		}],
		"sort-vars": [2, {"ignoreCase": true}],
		"space-before-blocks": 2,
		"space-before-function-paren": 2,
		"space-infix-ops": [2, {"int32Hint": false}],
		"space-in-parens": [2, "never"],
		"space-unary-ops": [2, {"words": true, "nonwords": false}],
		"spaced-comment": [2, "always"],
		"strict": [2, "global"],
		"symbol-description": 2,
		"template-curly-spacing": [2, "never"],
		"unicode-bom": 2,
		"use-isnan": 2,
		"valid-typeof": 2,
		"yield-star-spacing": [2, {"before": true, "after": false}],
		"yoda": 2,
		"valid-jsdoc": [2, {"requireReturn": false}],
		"wrap-iife": 2,
		"wrap-regex": 2,

		// WARNINGS

        "array-callback-return": 1,
        "complexity": 1,
		"jsx-a11y/click-events-have-key-events": 1,
		"jsx-a11y/no-static-element-interactions": 1,
        "no-console": 1,
		"no-warning-comments": [1, {"terms": ["todo", "fixme", "future"], "location": "anywhere"}],
		"react/jsx-handler-names": [1, {"eventHandlerPrefix": "_handle", "eventHandlerPropPrefix": "on"}],
		"react/no-find-dom-node": 1,
		"react/no-unused-prop-types": [1, {"skipShapeProps": true}],
		"react/prefer-es6-class": 1,
		"prefer-rest-params": 1,

		// DISABLED

        "arrow-body-style": [0, "as-needed"],
		"camelcase": 0,
		"class-methods-use-this": 0,
		"curly": 0,
		"default-case": 0,
		"eol-last": 0,
		"func-names": 0,
		"id-blacklist": [0, "data", "err", "e", "cb", "callback"],
		"id-length": [0, {"min": 3, "max": 30, "exceptions": ["i", "x"]}],
		"id-match": [0, "^[a-z]+([A-Z][a-z]+)*$", {"properties": false}],
		"import/max-dependencies": 0,
		"import/no-dynamic-require": 0,
		"import/no-extraneous-dependencies": 0,
        "import/no-internal-modules": 0,
        "import/no-named-as-default": 0,
        "import/no-nodejs-modules": 0,
        "import/no-restricted-paths": 0,
		"import/no-unassigned-import": 0,
		"import/no-webpack-loader-syntax": 0,
        "import/order": 0,
		"import/unambiguous": 0,
		"init-declarations": 0,
		"jsx-a11y/label-has-for": 0,
		"line-comment-position": 0,
		"linebreak-style": 0,
		"lines-around-comment": [0, {"beforeBlockComment": true, "beforeLineComment": true}],
		"multiline-ternary": 0,
		"new-cap": 0,
		"newline-after-var": [0, "always"],
		"no-case-declarations": 0,
		"no-confusing-arrow": 0,
		"no-continue": 0,
		"no-empty-function": 0,
		"no-eq-null": 0,
		"no-extra-parens": 0,
		"no-invalid-this": 0,
		"no-extra-label": 0,
		"no-magic-numbers": 0,
		"no-mixed-operators": 0,
		"no-mixed-requires": 0,
		"no-negated-condition": 0,
		"newline-before-return": 0,
		"no-param-reassign": 0,
		"no-plusplus": 0,
		"no-restricted-globals": 0,
		"no-restricted-imports": 0,
		"no-restricted-properties": 0,
		"no-shadow": 0,
		"no-ternary": 0,
		"no-tabs": 0,
		"no-undefined": 0,
		"no-underscore-dangle": 0,
		"no-unneeded-ternary": 0,
		"no-unused-labels": 0,
		"no-use-before-define": 0,
		"no-useless-return": 0,
		"object-curly-newline": 0,
		"object-curly-spacing": [0, "never"],
		"object-property-newline": 0,
		"one-var": [0, "always"],
		"padded-blocks": [0, "never"],
		"quotes": 0,
		"react/forbid-component-props": 0,
		"react/jsx-filename-extension": 0,
		"react/jsx-first-prop-new-line": 0,
		"react/jsx-no-bind": 0,
		"react/jsx-no-literals": 0,
		"react/no-set-state": 0,
		"react/no-string-refs": 0,
		"sort-keys": [0, "asc", {"caseSensitive": false, "natural": true}],
		"vars-on-top": 0
	},
	"settings": {
        "import/ignore": ["node_modules", "\.(css|json|less|md|styl)$"]
    }
};
